unit Vraag4_U;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TfrmVraag4 = class(TForm)
    Label1: TLabel;
    redVertoon: TRichEdit;
    Label2: TLabel;
    btnLaai: TButton;
    btnVerwyderDuplikate: TButton;
    btnMeesterSpelers: TButton;
    procedure btnLaaiClick(Sender: TObject);
    procedure vertoon;
    procedure btnVerwyderDuplikateClick(Sender: TObject);
    procedure btnMeesterSpelersClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmVraag4: TfrmVraag4;
  arrName: array [1..50] of String;
  arrTellings: array [1..50] of Integer;
  iTel: integer = 0;

  arrMeesters: array[1..30] of String;
  iMeesterTel: Integer;

implementation

{$R *.dfm}


procedure TfrmVraag4.btnVerwyderDuplikateClick(Sender: TObject);
var
  arrTempName: array [1..50] of String;
  arrTempTellings: array [1..50] of Integer;
  i, j, iNuweTel : Integer;
  bGevind : boolean;
begin
   // Vraag 4.1 Verwyder laer duplikate
     iNuweTel := 0;
     for i := 1 to iTel do
      begin
        bGevind := false;
        for j := 1 to  iNuweTel do
           begin
             if arrName[i] = arrTempName[j] then
              begin
                bGevind := true;
                if arrTellings[i] > arrTempTellings[j] then
                 arrTempTellings[j] := arrTellings[i];
              end;
           end;
           if NOT bGevind then
             begin
               Inc(iNuweTel);
               arrTempName[iNuweTel] := arrName[i];
               arrTempTellings[iNuweTel] := arrTellings[i];
             end;
      end;
      iTel := iNuweTel;
      for i := 1 to iTel do
        begin
          arrName[i] := arrTempName[i];
          arrTellings[i] := arrTempTellings[i];
        end;
     vertoon;
end;


procedure TfrmVraag4.btnMeesterSpelersClick(Sender: TObject);
var
  i, j, iTot, iGem : integer;
  sTemp : String;
begin
  // Vraag 4.2 Kry Meesters en vertoon gesorteerde lys
  iTot := 0;
  for i := 1 to iTel do
    iTot := iTot + arrTellings[i];
  iGem := Round(iTot / iTel);

  iMeesterTel := 0;
  for i := 1 to iTel do
   if arrTellings[i] > iGem then
     begin
        Inc(iMeesterTel);
        arrMeesters[iMeesterTel] := arrName[i] + '#' + IntToStr(arrTellings[i]);
     end;

   for i := 1 to iMeesterTel - 1 do
    for j := i + 1 to iMeesterTel do
      if arrMeesters[i] > arrMeesters[j]  then
        begin
          sTemp := arrMeesters[i];
          arrMeesters[i] := arrMeesters[j];
          arrMeesters[j] := sTemp;
        end;

   redVertoon.Clear;
   redVertoon.Lines.Add('MEESTERSPELERS');
   redVertoon.Lines.Add('Tellings bokant ''n gemiddeld van ' + IntToStr(iGem));
   for i := 1 to iMeesterTel do
     redVertoon.Lines.Add(arrMeesters[i]);
end;



// Kode wat voorsien is

procedure TfrmVraag4.btnLaaiClick(Sender: TObject);
var
  tTellingsLeer: TextFile;
  sReel : String;
  iKommaPos: Integer;
begin
   iTel :=0;
   AssignFile(tTellingsLeer, 'Tellings.txt');
   Reset(tTellingsLeer);
   while NOT EOF(tTellingsLeer) do
    begin
      Inc(iTel);
      Readln(tTellingsLeer, sReel);
      iKommaPos := Pos(',',sReel);
      arrName[iTel] := Copy(sReel,1,iKommaPos-1);
      arrTellings[iTel] := StrToInt(Copy(sReel,iKommaPos+1));
    end;
    CloseFile(tTellingsLeer);
    vertoon;
end;


procedure TfrmVraag4.vertoon;
var
  i : integer;
begin
   redVertoon.clear;
   redVertoon.Paragraph.TabCount := 1;
   redVertoon.Paragraph.Tab[0] := 120;
   redVertoon.Lines.Add('NAAM' + #9 + 'TELLING');
   for i := 1 to iTel do
    begin
      redVertoon.Lines.Add(arrName[i] + #9 + IntToStr(arrTellings[i]));
    end;
end;

end.
